image: ruiadr/php:latest

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"
  GIT_DEPTH: "0"

stages:
  - php
  - sonarcloud

test:ruiadr/utils:php8.1:
  stage: php
  image:
    name: ruiadr/php:8.1
    docker:
      user: www-data
  script:
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress
    - php vendor/bin/phpunit

test:ruiadr/utils:php8.2:
  stage: php
  image:
    name: ruiadr/php:8.2
    docker:
      user: www-data
  script:
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress
    - php vendor/bin/phpunit

# On utilise la dernière version de PHP pour générer nos rapports car dans notre
# cas, il n'y a pas de différences quelque soit la version de PHP qui est testée.
test:ruiadr/utils:php8.3:
  stage: php
  image:
    name: ruiadr/php:8.3-xdebug
    docker:
      user: www-data
  script:
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress
    - php vendor/bin/phpunit --log-junit=tests.xml --coverage-clover=coverage.xml
  artifacts:
    expire_in: 3600 seconds
    paths:
    - coverage.xml
    - tests.xml

sonarcloud-check:
  stage: sonarcloud
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  script:
    - sonar-scanner
  only:
    - merge_requests
    - master
    - develop